//---------------------------------------------------------------------------
#include <windows.h>
#include <stdio.h>
#include <fcntl.h>
#include <io.h>
#include <sys\stat.h>
#include "chessfuncs.h"

//#define _loaded_

typedef struct{
 DWORD mVersion;
 HWND mHwnd;
 BOOL mKeep;
} LOADINFO;

#ifdef _loaded_
extern "C" __declspec(dllexport) void __stdcall LoadDll(LOADINFO *ld)
{
 //---
}
//---------------------------------------------------------------------------

extern "C" __declspec(dllexport) int __stdcall UnloadDLL(int mTimeout)
{
 //---
 return 0;
}
//---------------------------------------------------------------------------
#endif

extern "C" __declspec(dllexport) int __stdcall validmoves(HWND mWnd, HWND aWnd, char *data, char *parms, BOOL show, BOOL nopause)
{
 char board[105];
 char gfield[4], lastfrom[4], lastto[4], dims[3]={0}, variant[2]={0};
 int fx, fy;
 char wmoved[4], bmoved[4];
 if(sscanf(data,"%104s %3s %3s %3s %3s %3s %1s", board, gfield, lastfrom, lastto, wmoved, bmoved, variant) < 6)
 {
  sprintf(data, "ERROR: parameters are fucked..");
  return 3;
 }

 lastfrom[0] = toupper(lastfrom[0]) - 65;
 lastfrom[1] = (lastfrom[1] - 49) + (lastfrom[2]=='0'?9:0);
 lastto[0] = toupper(lastto[0]) - 65;
 lastto[1] = (lastto[1] - 49) + (lastto[2]=='0'?9:0);
 switch(variant[0]) {
  case 'n': dims[0]=8; dims[1]=8; break;
  case 'f': dims[0]=8; dims[1]=8; break;
  case 'c': dims[0]=10; dims[1]=8; break;
  case 'C': dims[0]=10; dims[1]=10; break;
  case 'g': dims[0]=10; dims[1]=8; break;
  case 'G': dims[0]=10; dims[1]=10; break;
  case 'o': dims[0]=10; dims[1]=10; break;
  default: dims[0]=8; dims[1]=8; variant[0]='n'; break;
 }
 dims[2]=variant[0];

 unsigned char valids[50];
 char vc = getvalidmoves(valids, toupper(gfield[0]) - 65, (gfield[1] - 49) + (gfield[2]=='0'?9:0), board, lastfrom, lastto, wmoved, bmoved, dims);

 data[0]=0;
 for(long i=0;i<vc;i++)
 {
  if (valids[i]>99) sprintf(data+strlen(data)," w%d",valids[i]-99);
  else sprintf(data+strlen(data)," %c%d",((int)valids[i]%dims[0])+65,(int)(valids[i]/dims[0]) + 1);
 }

 return 3;
}
//---------------------------------------------------------------------------

extern "C" __declspec(dllexport) int __stdcall dangermoves(HWND mWnd, HWND aWnd, char *data, char *parms, BOOL show, BOOL nopause)
{
 char board[105];
 char gfield[4], dims[3]={0}, variant[2]={0};
 int fx, fy;
 if(sscanf(data,"%104s %3s %1s", board, gfield, variant) < 2)
 {
  sprintf(data, "ERROR: parameters are fucked..");
  return 3;
 }

 fx = toupper(gfield[0]) - 65;
 fy = (gfield[1] - 49) + (gfield[2]=='0'?9:0);
 switch(variant[0]) {
  case 'n': dims[0]=8; dims[1]=8; break;
  case 'f': dims[0]=8; dims[1]=8; break;
  case 'c': dims[0]=10; dims[1]=8; break;
  case 'C': dims[0]=10; dims[1]=10; break;
  case 'g': dims[0]=10; dims[1]=8; break;
  case 'G': dims[0]=10; dims[1]=10; break;
  case 'o': dims[0]=10; dims[1]=10; break;
  default: dims[0]=8; dims[1]=8; variant[0]='n'; break;
 }
 dims[2]=variant[0];

 if(dims[2]=='o'&&fx=='W'-65)
 {
  switch(fy)
  {
   case 0: fx=-1; fy=-1; break;
   case 1: fx=10; fy=-1; break;
   case 2: fx=10; fy=10; break;
   case 3: fx=-1; fy=10; break;
   default: return -1;
  }
 }

 char movetox, movetoy, afi;
 char dangers[50], dc = 0;

                       //                                         knight/chancelor/archbishop

                        char kmpx[] = {-2, -2, -1, -1,  1, 1,  2, 2};
                        char kmpy[] = {-1,  1, -2,  2, -2, 2, -1, 1};
                        for(char i=0;i<8;i++)
                        {
                         movetox = fx + kmpx[i];
                         movetoy = fy + kmpy[i];
                         afi = (movetoy*dims[0])+movetox;
                         if(movetox >= 0 && movetox < dims[0] && movetoy >= 0 && movetoy < dims[1])
                         {
                          char fpiece = tolower(board[afi]);
                          if(fpiece == 'n' || fpiece == 'c' || fpiece == 'a')
                           { dangers[dc] = (movetoy*dims[0]+movetox); dc++; }
                         }
                         else if (dims[2] == 'o')
                         {
                          char ind=-1;
                          if (movetox == -1 && movetoy == -1) ind=100;
                          else if (movetox == 10 && movetoy == -1) ind=101;
                          else if (movetox == 10 && movetoy == 10) ind=102;
                          else if (movetox == -1 && movetoy == 10) ind=103;
                          if (ind!=-1)
                          {
                            char fpiece = tolower(board[ind]);
                            if(fpiece == 'n')
                            { dangers[dc] = ind; dc++; }
                          }
                         }
                        }

                       //               diagonal - bishop/queen/king/pawn/archbishop/wizard[1]
                        char bmpx[] = {-1, -1,  1, 1};
                        char bmpy[] = {-1,  1, -1, 1};
                        for(char i=0;i<4;i++)
                        {
                         bool goon=true;
                         char test=0;
                         movetox = fx;
                         movetoy = fy;
                         while (goon) {
                          movetox += bmpx[i];
                          movetoy += bmpy[i];
                          afi = (movetoy*dims[0])+movetox;
                          test++;
                          if(movetox >= 0 && movetox < dims[0] && movetoy >= 0 && movetoy < dims[1])
                          {
                           char fpiece = tolower(board[afi]);
                            if(fpiece == 'q' ||
                               fpiece == 'b' ||
                               fpiece == 'a' ||
                              (fpiece == 'w' && test == 1) ||
                              (fpiece == 'k' && test == 1) ||
                              (fpiece == 'p' && test == 1 && bmpy[i] == ((board[afi]&32)? 1 : -1)))
                            { dangers[dc] = afi; dc++; }
                            if(fpiece != '0') goon = false;
                          }
                          else if (dims[2] == 'o')
                          {
                            char ind=-1;
                            if (movetox == -1 && movetoy == -1) ind=100;
                            else if (movetox == 10 && movetoy == -1) ind=101;
                            else if (movetox == 10 && movetoy == 10) ind=102;
                            else if (movetox == -1 && movetoy == 10) ind=103;
                            if (ind!=-1)
                            {
                              char fpiece = tolower(board[ind]);
                              if(fpiece == 'q' ||
                                 fpiece == 'b' ||
                                (fpiece == 'w' && test == 1) ||
                                (fpiece == 'k' && test == 1))
                              { dangers[dc] = ind; dc++; }
                            }
                            goon = false;
                          }
                          else goon = false;
                         }
                        }

                       //                      straight - rook/queen/king/chancelor/champion[1]
                        char rmpx[] = {-1, 1,  0, 0};
                        char rmpy[] = { 0, 0, -1, 1};
                        for(char i=0;i<4;i++)
                        {
                         bool goon=true;
                         char test=0;
                         movetox = fx;
                         movetoy = fy;
                         while (goon) {
                          movetox += rmpx[i];
                          movetoy += rmpy[i];
                          afi = (movetoy*dims[0])+movetox;
                          test++;
                          if(movetox >= 0 && movetox < dims[0] && movetoy >= 0 && movetoy < dims[1])
                          {
                           char fpiece = tolower(board[afi]);
                            if(fpiece == 'q' ||
                               fpiece == 'r' ||
                               fpiece == 'c' ||
                              (fpiece == 'h' && test == 1) ||
                              (fpiece == 'k' && test == 1))
                            { dangers[dc] = afi; dc++; }
                            if(fpiece != '0') goon = false;
                          }
                          else goon = false;
                         }
                        }

                       //                                         champion
                        char cmpx[] = {-2, -2, -2, 0, 2, 2,  2,  0};
                        char cmpy[] = {-2,  0,  2, 2, 2, 0, -2, -2};
                        for(char i=0;i<8;i++)
                        {
                         movetox = fx + cmpx[i];
                         movetoy = fy + cmpy[i];
                         afi = (movetoy*dims[0])+movetox;
                         if(movetox >= 0 && movetox < dims[0] && movetoy >= 0 && movetoy < dims[1])
                         {
                          char fpiece = tolower(board[afi]);
                          if(fpiece == 'h')
                           { dangers[dc] = afi; dc++; }
                         }
                         else if (dims[2] == 'o') {
                            char ind=-1;
                            if (movetox == -1 && movetoy == -1) ind=100;
                            else if (movetox == 10 && movetoy == -1) ind=101;
                            else if (movetox == 10 && movetoy == 10) ind=102;
                            else if (movetox == -1 && movetoy == 10) ind=103;
                            if (ind!=-1)
                            {
                              char fpiece = tolower(board[ind]);
                              if(fpiece == 'h')
                              { dangers[dc] = ind; dc++; }
                            }
                          }
                        }

                       //                                         wizard
                        char wmpx[] = {-3, -3, -1, -1,  1, 1,  3, 3};
                        char wmpy[] = {-1,  1, -3,  3, -3, 3, -1, 1};
                        for(char i=0;i<8;i++)
                        {
                         movetox = fx + wmpx[i];
                         movetoy = fy + wmpy[i];
                         afi = (movetoy*dims[0])+movetox;
                         if(movetox >= 0 && movetox < dims[0] && movetoy >= 0 && movetoy < dims[1])
                         {
                          char fpiece = tolower(board[afi]);
                          if(fpiece == 'w')
                           { dangers[dc] = afi; dc++; }
                         }
                         else if (dims[2] == 'o') {
                            char ind=-1;
                            if (movetox == -1 && movetoy == -1) ind=100;
                            else if (movetox == 10 && movetoy == -1) ind=101;
                            else if (movetox == 10 && movetoy == 10) ind=102;
                            else if (movetox == -1 && movetoy == 10) ind=103;
                            if (ind!=-1)
                            {
                              char fpiece = tolower(board[ind]);
                              if(fpiece == 'w')
                              { dangers[dc] = ind; dc++; }
                            }
                          }
                        }

 data[0]=0;
 for(long i=0;i<dc;i++)
 {
  if (dangers[i]>99) sprintf(data+strlen(data)," w%d",dangers[i]-99);
  else sprintf(data+strlen(data)," %c%d",(dangers[i]%dims[0])+65,(int)(dangers[i]/dims[0]) + 1);
 }

 return 3;
}
//---------------------------------------------------------------------------

extern "C" __declspec(dllexport) int __stdcall gameover(HWND mWnd, HWND aWnd, char *data, char *parms, BOOL show, BOOL nopause)
{
 char board[105];
 char color[2], lastfrom[4], lastto[4], dims[3]={0}, variant[2]={0};
 int fx, fy;
 char wmoved[4], bmoved[4];
 if(sscanf(data,"%104s %1s %3s %3s %3s %3s %1s", board, color, lastfrom, lastto, wmoved, bmoved, variant) < 6)
 {
  sprintf(data, "ERROR: parameters are fucked..");
  return 3;
 }

 lastfrom[0] = toupper(lastfrom[0]) - 65;
 lastfrom[1] = (lastfrom[1] - 49) + (lastfrom[2]=='0'?9:0);
 lastto[0] = toupper(lastto[0]) - 65;
 lastto[1] = (lastto[1] - 49) + (lastto[2]=='0'?9:0);
 switch(variant[0]) {
  case 'n': dims[0]=8; dims[1]=8; break;
  case 'f': dims[0]=8; dims[1]=8; break;
  case 'c': dims[0]=10; dims[1]=8; break;
  case 'C': dims[0]=10; dims[1]=10; break;
  case 'g': dims[0]=10; dims[1]=8; break;
  case 'G': dims[0]=10; dims[1]=10; break;
  case 'o': dims[0]=10; dims[1]=10; break;
  default: dims[0]=8; dims[1]=8; variant[0]='n'; break;
 }
 dims[2]=variant[0];

 char kx=-1,ky=-1;
  for(char i=0;i<dims[1]&&kx==-1;i++)
   for(char j=0;j<dims[0]&&kx==-1;j++)
    if(board[(i*dims[0] + j)] == ('K'^(tolower(color[0])=='w'?0:32)))
    { kx=j; ky=i; }

 if (kx == -1)
 {
  sprintf(data, "ERR: goddammit!");
  return 3;
 }

 if(ischeck(kx,ky,(tolower(color[0]) == 'w' ? 32 : 0),board,dims))
  sprintf(data, "check");
 else
  sprintf(data, "stale");

  unsigned char valids[50];
  for(char i=0;i<dims[1];i++)
   for(char j=0;j<dims[0];j++)
    if((board[(i*dims[0] + j)]&32) == (tolower(color[0])=='w'?0:32))
     if(getvalidmoves(valids, j, i, board, lastfrom, lastto, wmoved, bmoved, dims) > 0)
     {
      sprintf(data, "fine");
      return 3;
     }
 sprintf(data+strlen(data), "mate");
 return 3;
}
//---------------------------------------------------------------------------

extern "C" __declspec(dllexport) int __stdcall getattackers(HWND mWnd, HWND aWnd, char *data, char *parms, BOOL show, BOOL nopause)
{
 char board[105];
 char gfield[4], dims[3]={0}, variant[2]={0};
 int fx, fy;
 if(sscanf(data,"%105s %3s %1s", board, gfield, variant) < 2)
 {
  sprintf(data, "ERROR: parameters are fucked..");
  return 3;
 }

 fx = toupper(gfield[0]) - 65;
 fy = (gfield[1] - 49) + (gfield[2]=='0'?9:0);

 switch(variant[0]) {
  case 'n': dims[0]=8; dims[1]=8; break;
  case 'f': dims[0]=8; dims[1]=8; break;
  case 'c': dims[0]=10; dims[1]=8; break;
  case 'C': dims[0]=10; dims[1]=10; break;
  case 'g': dims[0]=10; dims[1]=8; break;
  case 'G': dims[0]=10; dims[1]=10; break;
  case 'o': dims[0]=10; dims[1]=10; break;
  default: dims[0]=8; dims[1]=8; variant[0]='n'; break;
 }
 dims[2]=variant[0];
 char opp;
 if(dims[2]=='o'&&fx=='W'-65)
 {
  opp = (board[100+fy]&32) ? 0 : 32;
  switch(fy)
  {
   case 0: fx=-1; fy=-1; break;
   case 1: fx=10; fy=-1; break;
   case 2: fx=10; fy=10; break;
   case 3: fx=-1; fy=10; break;
   default: return -1;
  }
 }
 opp = (board[(fy*dims[0]+fx)]&32) ? 0 : 32;
 char movetox, movetoy, afi;
 char dangers[50], dc = 0;

                       //                                         knights

                        char kmpx[] = {-2, -2, -1, -1,  1, 1,  2, 2};
                        char kmpy[] = {-1,  1, -2,  2, -2, 2, -1, 1};
                        for(char i=0;i<8;i++)
                        {
                         movetox = fx + kmpx[i];
                         movetoy = fy + kmpy[i];
                         afi = (movetoy*dims[0])+movetox;
                         if(movetox >= 0 && movetox < dims[0] && movetoy >= 0 && movetoy < dims[1])
                         {
                           char fpiece = tolower(board[afi]);
                           if((fpiece == 'n' ||
                               fpiece == 'c' ||
                               fpiece == 'a') && (board[afi]&32) == opp)
                           { dangers[dc] = afi; dc++; }
                         }
                         else if (dims[2] == 'o')
                         {
                          char ind=-1;
                          if (movetox == -1 && movetoy == -1) ind=100;
                          else if (movetox == 10 && movetoy == -1) ind=101;
                          else if (movetox == 10 && movetoy == 10) ind=102;
                          else if (movetox == -1 && movetoy == 10) ind=103;
                          if (ind!=-1)
                          {
                            char fpiece = tolower(board[ind]);
                            if(fpiece == 'n' && (board[ind]&32) == opp)
                            { dangers[dc] = ind; dc++; }
                          }
                         }
                        }

                       //               diagonal - bishop/queen/king/pawn/[1]
                        char bmpx[] = {-1, -1,  1, 1};
                        char bmpy[] = {-1,  1, -1, 1};
                        for(char i=0;i<4;i++)
                        {
                         bool goon=true;
                         char test=0;
                         movetox = fx;
                         movetoy = fy;
                         while (goon) {
                          movetox += bmpx[i];
                          movetoy += bmpy[i];
                          afi = (movetoy*dims[0])+movetox;
                          test++;
                          if(movetox >= 0 && movetox < dims[0] && movetoy >= 0 && movetoy < dims[1])
                          {
                            char fpiece = tolower(board[afi]);
                            if((board[afi]&32) == opp &&
                               (fpiece == 'q' ||
                                fpiece == 'b' ||
                                fpiece == 'a' ||
                               (fpiece == 'w' && test == 1) ||
                               (fpiece == 'k' && test == 1) ||
                               (fpiece == 'p' && test == 1 && bmpy[i] == ((board[afi]&32)? 1 : -1))))
                            { dangers[dc] = afi; dc++; }
                            if(fpiece != '0') goon = false;
                          }
                          else if (dims[2] == 'o')
                          {
                           char ind=-1;
                           if (movetox == -1 && movetoy == -1) ind=100;
                           else if (movetox == 10 && movetoy == -1) ind=101;
                           else if (movetox == 10 && movetoy == 10) ind=102;
                           else if (movetox == -1 && movetoy == 10) ind=103;
                           if (ind!=-1)
                           {
                             char fpiece = tolower(board[ind]);
                             if((fpiece == 'q' ||
                                 fpiece == 'b' ||
                                (fpiece == 'w' && test == 1) ||
                                (fpiece == 'k' && test == 1)) && (board[ind]&32) == opp)
                             { dangers[dc] = ind; dc++; }
                           }
                           goon = false;
                          }
                          else goon = false;
                         }
                        }

                       //                      straight - rook/queen/king/champion[1]
                        char rmpx[] = {-1, 1,  0, 0};
                        char rmpy[] = { 0, 0, -1, 1};
                        for(char i=0;i<4;i++)
                        {
                         bool goon=true;
                         char test=0;
                         movetox = fx;
                         movetoy = fy;
                         while (goon) {
                          movetox += rmpx[i];
                          movetoy += rmpy[i];
                          afi = (movetoy*dims[0])+movetox;
                          test++;
                          if(movetox >= 0 && movetox < dims[0] && movetoy >= 0 && movetoy < dims[1])
                          {
                            char fpiece = tolower(board[afi]);
                            if(fpiece != '0' && (board[afi]&32) == opp &&
                               (fpiece == 'q' ||
                                fpiece == 'r' ||
                                fpiece == 'c' ||
                               (fpiece == 'h' && test == 1) ||
                               (fpiece == 'k' && test == 1)))
                            { dangers[dc] = afi; dc++; }
                            if(fpiece != '0') goon = false;
                          }
                          else goon = false;
                         }
                        }

                       //                                         champion
                        char cmpx[] = {-2, -2, -2, 0, 2, 2,  2,  0};
                        char cmpy[] = {-2,  0,  2, 2, 2, 0, -2, -2};
                        for(char i=0;i<8;i++)
                        {
                         movetox = fx + cmpx[i];
                         movetoy = fy + cmpy[i];
                         afi = (movetoy*dims[0])+movetox;
                         if(movetox >= 0 && movetox < dims[0] && movetoy >= 0 && movetoy < dims[1])
                         {
                          char fpiece = tolower(board[afi]);
                          if(fpiece == 'h' && (board[afi]&32) == opp)
                           { dangers[dc] = (movetoy*dims[0]+movetox); dc++; }
                         }
                         else if (dims[2] == 'o')
                         {
                          char ind=-1;
                          if (movetox == -1 && movetoy == -1) ind=100;
                          else if (movetox == 10 && movetoy == -1) ind=101;
                          else if (movetox == 10 && movetoy == 10) ind=102;
                          else if (movetox == -1 && movetoy == 10) ind=103;
                          if (ind!=-1)
                          {
                            char fpiece = tolower(board[ind]);
                            if(fpiece == 'h' && (board[ind]&32) == opp)
                            { dangers[dc] = ind; dc++; }
                          }
                         }
                        }

                       //                                         wizard
                        char wmpx[] = {-3, -3, -1, -1,  1, 1,  3, 3};
                        char wmpy[] = {-1,  1, -3,  3, -3, 3, -1, 1};
                        for(char i=0;i<8;i++)
                        {
                         movetox = fx + wmpx[i];
                         movetoy = fy + wmpy[i];
                         afi = (movetoy*dims[0])+movetox;
                         if(movetox >= 0 && movetox < dims[0] && movetoy >= 0 && movetoy < dims[1])
                         {
                          char fpiece = tolower(board[afi]);
                          if(fpiece == 'w' && (board[afi]&32) == opp)
                           { dangers[dc] = (movetoy*dims[0]+movetox); dc++; }
                         }
                         else if (dims[2] == 'o')
                         {
                          char ind=-1;
                          if (movetox == -1 && movetoy == -1) ind=100;
                          else if (movetox == 10 && movetoy == -1) ind=101;
                          else if (movetox == 10 && movetoy == 10) ind=102;
                          else if (movetox == -1 && movetoy == 10) ind=103;
                          if (ind!=-1)
                          {
                            char fpiece = tolower(board[ind]);
                            if(fpiece == 'w' && (board[ind]&32) == opp)
                            { dangers[dc] = ind; dc++; }
                          }
                         }
                        }

 data[0]=0;
 for(long i=0;i<dc;i++)
 {
  if (dangers[i]>99) sprintf(data+strlen(data)," w%d",dangers[i]-99);
  else sprintf(data+strlen(data)," %c%d",((int)dangers[i]%dims[0])+65,(int)(dangers[i]/dims[0]) + 1);
 }

 return 3;
}
//---------------------------------------------------------------------------

extern "C" __declspec(dllexport) int __stdcall getposrating(HWND mWnd, HWND aWnd, char *data, char *parms, BOOL show, BOOL nopause)
{
 char board[65];
 char turn[2], lastfrom[3], lastto[3], dims[3]={0};
 char wmoved[4], bmoved[4];
 if(sscanf(data,"%64s %1s %2s %2s %3s %3s", board, turn, lastfrom, lastto, wmoved, bmoved) < 6)
 {
  sprintf(data, "ERROR: parameters are fucked..");
  return 3;
 }
 data[0]=0;

 lastfrom[0] = toupper(lastfrom[0]) - 65;
 lastfrom[1] = lastfrom[1] - 49;
 lastto[0] = toupper(lastto[0]) - 65;
 lastto[1] = lastto[1] - 49;
 turn[0] = tolower(turn[0]);

 long ratingw, ratingb;
 rateposition(&ratingw, &ratingb, board, turn, wmoved, bmoved, true, dims);

 sprintf(data+strlen(data)," %d %d", ratingw, ratingb);
 return 3;
}
//---------------------------------------------------------------------------

extern "C" __declspec(dllexport) int __stdcall tblit(HWND mWnd, HWND aWnd, char *data, char *parms, BOOL show, BOOL nopause)
{
 char f1[100], f2[100];
 int perc;
 if (sscanf(data, "%s %s %d", f1, f2, &perc) != 3) {
   sprintf(data, "ERR: insufficient parameters");
   return 3;
 }
 if (perc<0) perc=0;
 else if (perc>100) perc=100;

 int fh=open(f1,O_RDONLY|O_BINARY);
 if (fh == -1) {
   sprintf(data, "ERR: unable to open file '%s'...", f1);
   return 3;
 }
 int len=lseek(fh,0,SEEK_END);
 char *file1=(char*)malloc(len);
 lseek(fh,0,SEEK_SET);
 read(fh, file1, len);
 close(fh);

 if (!(file1[0] == 'B' && file1[1] == 'M')) {
   free(file1);
   sprintf(data, "ERR: file '%s' is not a Bitmap...", f1);
   return 3;
 }

 fh=open(f2,O_RDONLY|O_BINARY);
 if (fh == -1) {
   free(file1);
   sprintf(data, "ERR: unable to open file '%s'...", f2);
   return 3;
 }
 len=lseek(fh,0,SEEK_END);
 char *file2=(char*)malloc(len);
 lseek(fh,0,SEEK_SET);
 read(fh, file2, len);
 close(fh);

 if (!(file2[0] == 'B' && file2[1] == 'M')) {
   free(file1);
   free(file2);
   sprintf(data, "ERR: file '%s' is not a Bitmap...", f2);
   return 3;
 }

 if (((long*)&file1[18])[0] != ((long*)&file2[18])[0] ||
     ((long*)&file1[22])[0] != ((long*)&file2[22])[0] ||
     ((short*)&file1[28])[0] != ((short*)&file2[28])[0] ) {
   free(file1);
   free(file2);
   sprintf(data, "ERR: Bitmap-dimensions/bitdepth don't match or corrupt files...");
   return 3;
 }

 if (((short*)&file1[28])[0] == 24 || ((short*)&file1[28])[0] == 32) {
   unsigned char *p1=file1+54, *p2=file2+54;
   unsigned char *maxp=file1+len;
   while (p1<maxp) {
     p1[0]=(p1[0]*(100-perc)+p2[0]*perc)/100;
     p1++;
     p2++;
   }
 }
 else if (((short*)&file1[28])[0] == 16) {
   unsigned short *p1=(unsigned short*)file1+27, *p2=(unsigned short*)file2+27;
   unsigned short *maxp=(unsigned short*)file1+(len>>1);
   unsigned char r, g, b;
   while (p1<maxp) {
     r=((p1[0]>>10)*(100-perc)+(p2[0]>>10)*perc)/100;
     g=(((p1[0]>>5)&31)*(100-perc)+((p2[0]>>5)&31)*perc)/100;
     b=((p1[0]&31)*(100-perc)+(p2[0]&31)*perc)/100;
     p1[0]=((r&63)<<10)+((g&31)<<5)+(b&31);
     p1++;
     p2++;
   }
 }
 else {
   free(file1);
   free(file2);
   sprintf(data, "ERR: unsupported bitdepth");
   return 3;
 }

 fh=open("tblit.bmp",O_CREAT|O_TRUNC|O_BINARY|O_WRONLY, S_IREAD|S_IWRITE);
 write(fh,file1,len);
 close(fh);

 free(file1);
 free(file2);
 sprintf(data, "OK: .");
 return 3;
}
//---------------------------------------------------------------------------


